---

stages:
  - build
  - trigger

image: docker.io/library/docker:dind

variables:
  DOCKER_TLS_CERTDIR: "/certs"

services:
  - docker:dind

before_script:
  - echo "$DOCKER_TOKEN" |
    docker login docker.io -u $DOCKER_USER --password-stdin
  - echo "$GITLAB_TOKEN" |
    docker login registry.gitlab.com -u $GITLAB_USER --password-stdin
  - docker context create builders
  - docker buildx create builders --use

.build:
  stage: build
  tags:
    - dockerwest
  script:
    - cd build
    - docker buildx build
      --platform linux/arm64/v8,linux/amd64
      --build-arg DEBIAN_NAME=$DEBIAN_NAME
      --build-arg PHP_VERSION=$PHP_VERSION
      --tag registry.gitlab.com/dockerwest/image/php:$IMG_TAG
      --tag docker.io/dockerwest/php:$IMG_TAG
      --push
      .

build:7.2:
  variables:
    PHP_VERSION: "7.2"
    IMG_TAG: "7.2"
    DEBIAN_NAME: bookworm
  extends: .build
  only:
    - main

build:7.3:
  variables:
    PHP_VERSION: "7.3"
    IMG_TAG: "7.3"
    DEBIAN_NAME: bookworm
  extends: .build
  only:
    - main

build:7.4:
  variables:
    PHP_VERSION: "7.4"
    IMG_TAG: "7.4"
    DEBIAN_NAME: bookworm
  extends: .build
  only:
    - main

build:8.0:
  variables:
    PHP_VERSION: "8.0"
    IMG_TAG: "8.0"
    DEBIAN_NAME: bookworm
  extends: .build
  only:
    - main

build:8.1:
  variables:
    PHP_VERSION: "8.1"
    IMG_TAG: "8.1"
    DEBIAN_NAME: bookworm
  extends: .build
  only:
    - main

build:8.2:
  variables:
    PHP_VERSION: "8.2"
    IMG_TAG: "8.2"
    DEBIAN_NAME: bookworm
  extends: .build
  only:
    - main

build:8.3:
  variables:
    PHP_VERSION: "8.3"
    IMG_TAG: "8.3"
    DEBIAN_NAME: bookworm
  extends: .build
  only:
    - main

#build:8.4:
  #variables:
    #PHP_VERSION: "8.4"
    #IMG_TAG: "8.4"
    #DEBIAN_NAME: bookworm
  #extends: .build
  #only:
    #- main

trigger:php-laravel:
  stage: trigger
  trigger:
    project: DockerWest/image/php-laravel

trigger:php-magento1:
  stage: trigger
  trigger:
    project: DockerWest/image/php-magento1

trigger:php-magento2:
  stage: trigger
  trigger:
    project: DockerWest/image/php-magento2

trigger:php-pimcore:
  stage: trigger
  trigger:
    project: DockerWest/image/php-pimcore

trigger:php-symfony:
  stage: trigger
  trigger:
    project: DockerWest/image/php-symfony

trigger:php-sylius:
  stage: trigger
  trigger:
    project: DockerWest/image/php-sylius

trigger:php-wordpress:
  stage: trigger
  trigger:
    project: DockerWest/image/php-wordpress
